/* export_dialog.c generated by valac 0.16.1, the Vala compiler
 * generated from export_dialog.vala, do not modify */

/*
 * DESCRIPTION      Map canvas for drawing nodes tree.
 * PROJECT          Mind Map Architect
 * AUTHOR           Ondrej Tuma <mcbig@zeropage.cz>
 *
 * Copyright (C) Ondrej Tuma 2011
 * Code is present with BSD licence.
 */
/* modules: Gtk*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_EXPORT_FILTER_ID (export_filter_id_get_type ())

#define TYPE_EXPORT_DIALOG (export_dialog_get_type ())
#define EXPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORT_DIALOG, ExportDialog))
#define EXPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORT_DIALOG, ExportDialogClass))
#define IS_EXPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORT_DIALOG))
#define IS_EXPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORT_DIALOG))
#define EXPORT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORT_DIALOG, ExportDialogClass))

typedef struct _ExportDialog ExportDialog;
typedef struct _ExportDialogClass ExportDialogClass;
typedef struct _ExportDialogPrivate ExportDialogPrivate;

#define TYPE_FILE_TAB (file_tab_get_type ())
#define FILE_TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_TAB, FileTab))
#define FILE_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_TAB, FileTabClass))
#define IS_FILE_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_TAB))
#define IS_FILE_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_TAB))
#define FILE_TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_TAB, FileTabClass))

typedef struct _FileTab FileTab;
typedef struct _FileTabClass FileTabClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ITAB (itab_get_type ())
#define ITAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ITAB, ITab))
#define IS_ITAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ITAB))
#define ITAB_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ITAB, ITabIface))

typedef struct _ITab ITab;
typedef struct _ITabIface ITabIface;

#define TYPE_TAB_LABEL (tab_label_get_type ())
#define TAB_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAB_LABEL, TabLabel))
#define TAB_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAB_LABEL, TabLabelClass))
#define IS_TAB_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAB_LABEL))
#define IS_TAB_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAB_LABEL))
#define TAB_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAB_LABEL, TabLabelClass))

typedef struct _TabLabel TabLabel;
typedef struct _TabLabelClass TabLabelClass;
typedef struct _FileTabPrivate FileTabPrivate;

#define TYPE_MIND_MAP (mind_map_get_type ())
#define MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIND_MAP, MindMap))
#define MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIND_MAP, MindMapClass))
#define IS_MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIND_MAP))
#define IS_MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIND_MAP))
#define MIND_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIND_MAP, MindMapClass))

typedef struct _MindMap MindMap;
typedef struct _MindMapClass MindMapClass;

typedef enum  {
	EXPORT_FILTER_ID_TXT,
	EXPORT_FILTER_ID_HTML,
	EXPORT_FILTER_ID_DHTML,
	EXPORT_FILTER_ID_PNG,
	EXPORT_FILTER_ID_MM
} ExportFilterID;

struct _ExportDialog {
	GtkFileChooserDialog parent_instance;
	ExportDialogPrivate * priv;
	FileTab* filetab;
	gchar* default_directory;
};

struct _ExportDialogClass {
	GtkFileChooserDialogClass parent_class;
};

struct _ExportDialogPrivate {
	GtkFileFilter* txt;
	GtkFileFilter* html;
	GtkFileFilter* dhtml;
	GtkFileFilter* png;
	GtkFileFilter* mm;
};

struct _ITabIface {
	GTypeInterface parent_iface;
	TabLabel* (*get_tablabel) (ITab* self);
	void (*set_tablabel) (ITab* self, TabLabel* value);
	GtkLabel* (*get_menulabel) (ITab* self);
	void (*set_menulabel) (ITab* self, GtkLabel* value);
	const gchar* (*get_title) (ITab* self);
	void (*set_title) (ITab* self, const gchar* value);
};

struct _FileTab {
	GtkScrolledWindow parent_instance;
	FileTabPrivate * priv;
	MindMap* mindmap;
	gchar* filepath;
};

struct _FileTabClass {
	GtkScrolledWindowClass parent_class;
};


static gpointer export_dialog_parent_class = NULL;

GType export_filter_id_get_type (void) G_GNUC_CONST;
GType export_dialog_get_type (void) G_GNUC_CONST;
GType file_tab_get_type (void) G_GNUC_CONST;
#define EXPORT_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_EXPORT_DIALOG, ExportDialogPrivate))
enum  {
	EXPORT_DIALOG_DUMMY_PROPERTY
};
ExportDialog* export_dialog_new (FileTab* filetab, const gchar* default_directory, GtkWindow* _parent);
ExportDialog* export_dialog_construct (GType object_type, FileTab* filetab, const gchar* default_directory, GtkWindow* _parent);
GtkFileFilter* export_dialog_create_filter (const gchar* name, gchar** patterns, int patterns_length1);
void export_dialog_on_response (ExportDialog* self, gint response_id);
static void _export_dialog_on_response_gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
void export_dialog_set_path (ExportDialog* self, const gchar* filepath);
GType tab_label_get_type (void) G_GNUC_CONST;
GType itab_get_type (void) G_GNUC_CONST;
GType mind_map_get_type (void) G_GNUC_CONST;
guint export_dialog_get_filter_id (ExportDialog* self);
const gchar* itab_get_title (ITab* self);
void export_dialog_restart_response (ExportDialog* self, gint response_id);
gchar* export_dialog_get_suffixed_filename (ExportDialog* self);
static void export_dialog_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GType export_filter_id_get_type (void) {
	static volatile gsize export_filter_id_type_id__volatile = 0;
	if (g_once_init_enter (&export_filter_id_type_id__volatile)) {
		static const GEnumValue values[] = {{EXPORT_FILTER_ID_TXT, "EXPORT_FILTER_ID_TXT", "txt"}, {EXPORT_FILTER_ID_HTML, "EXPORT_FILTER_ID_HTML", "html"}, {EXPORT_FILTER_ID_DHTML, "EXPORT_FILTER_ID_DHTML", "dhtml"}, {EXPORT_FILTER_ID_PNG, "EXPORT_FILTER_ID_PNG", "png"}, {EXPORT_FILTER_ID_MM, "EXPORT_FILTER_ID_MM", "mm"}, {0, NULL, NULL}};
		GType export_filter_id_type_id;
		export_filter_id_type_id = g_enum_register_static ("ExportFilterID", values);
		g_once_init_leave (&export_filter_id_type_id__volatile, export_filter_id_type_id);
	}
	return export_filter_id_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _export_dialog_on_response_gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
	export_dialog_on_response (self, response_id);
}


ExportDialog* export_dialog_construct (GType object_type, FileTab* filetab, const gchar* default_directory, GtkWindow* _parent) {
	ExportDialog * self = NULL;
	const gchar* _tmp0_ = NULL;
	FileTab* _tmp1_;
	FileTab* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar** _tmp7_ = NULL;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GtkFileFilter* _tmp9_ = NULL;
	GtkFileFilter* _tmp10_;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_ = NULL;
	gchar** _tmp15_;
	gint _tmp15__length1;
	GtkFileFilter* _tmp16_ = NULL;
	GtkFileFilter* _tmp17_;
	const gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar** _tmp21_ = NULL;
	gchar** _tmp22_;
	gint _tmp22__length1;
	GtkFileFilter* _tmp23_ = NULL;
	GtkFileFilter* _tmp24_;
	const gchar* _tmp25_ = NULL;
	gchar* _tmp26_;
	gchar** _tmp27_ = NULL;
	gchar** _tmp28_;
	gint _tmp28__length1;
	GtkFileFilter* _tmp29_ = NULL;
	GtkFileFilter* _tmp30_;
	gchar* _tmp31_;
	gchar** _tmp32_ = NULL;
	gchar** _tmp33_;
	gint _tmp33__length1;
	GtkFileFilter* _tmp34_ = NULL;
	GtkFileFilter* _tmp35_;
	FileTab* _tmp36_;
	const gchar* _tmp37_;
	g_return_val_if_fail (filetab != NULL, NULL);
	g_return_val_if_fail (default_directory != NULL, NULL);
	self = (ExportDialog*) g_object_new (object_type, NULL);
	_tmp0_ = _ ("Export file as");
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
	gtk_file_chooser_set_action ((GtkFileChooser*) self, GTK_FILE_CHOOSER_ACTION_SAVE);
	_tmp1_ = filetab;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->filetab);
	self->filetab = _tmp2_;
	_tmp3_ = default_directory;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (self->default_directory);
	self->default_directory = _tmp4_;
	gtk_dialog_add_button ((GtkDialog*) self, GTK_STOCK_CANCEL, (gint) GTK_RESPONSE_CANCEL);
	gtk_dialog_add_button ((GtkDialog*) self, GTK_STOCK_SAVE, (gint) GTK_RESPONSE_ACCEPT);
	gtk_dialog_set_default_response ((GtkDialog*) self, (gint) GTK_RESPONSE_ACCEPT);
	_tmp5_ = _ ("Plain Text");
	_tmp6_ = g_strdup ("*.txt");
	_tmp7_ = g_new0 (gchar*, 1 + 1);
	_tmp7_[0] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 1;
	_tmp9_ = export_dialog_create_filter (_tmp5_, _tmp8_, 1);
	_g_object_unref0 (self->priv->txt);
	self->priv->txt = _tmp9_;
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
	_tmp10_ = self->priv->txt;
	gtk_file_chooser_add_filter ((GtkFileChooser*) self, _tmp10_);
	_tmp11_ = _ ("Simple Web Page");
	_tmp12_ = g_strdup ("*.html");
	_tmp13_ = g_strdup ("*.htm");
	_tmp14_ = g_new0 (gchar*, 2 + 1);
	_tmp14_[0] = _tmp12_;
	_tmp14_[1] = _tmp13_;
	_tmp15_ = _tmp14_;
	_tmp15__length1 = 2;
	_tmp16_ = export_dialog_create_filter (_tmp11_, _tmp15_, 2);
	_g_object_unref0 (self->priv->html);
	self->priv->html = _tmp16_;
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
	_tmp17_ = self->priv->html;
	gtk_file_chooser_add_filter ((GtkFileChooser*) self, _tmp17_);
	_tmp18_ = _ ("Dynamic Web Page");
	_tmp19_ = g_strdup ("*.dhtml");
	_tmp20_ = g_strdup ("*.dhtm");
	_tmp21_ = g_new0 (gchar*, 2 + 1);
	_tmp21_[0] = _tmp19_;
	_tmp21_[1] = _tmp20_;
	_tmp22_ = _tmp21_;
	_tmp22__length1 = 2;
	_tmp23_ = export_dialog_create_filter (_tmp18_, _tmp22_, 2);
	_g_object_unref0 (self->priv->dhtml);
	self->priv->dhtml = _tmp23_;
	_tmp22_ = (_vala_array_free (_tmp22_, _tmp22__length1, (GDestroyNotify) g_free), NULL);
	_tmp24_ = self->priv->dhtml;
	gtk_file_chooser_add_filter ((GtkFileChooser*) self, _tmp24_);
	_tmp25_ = _ ("PNG Image");
	_tmp26_ = g_strdup ("*.png");
	_tmp27_ = g_new0 (gchar*, 1 + 1);
	_tmp27_[0] = _tmp26_;
	_tmp28_ = _tmp27_;
	_tmp28__length1 = 1;
	_tmp29_ = export_dialog_create_filter (_tmp25_, _tmp28_, 1);
	_g_object_unref0 (self->priv->png);
	self->priv->png = _tmp29_;
	_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
	_tmp30_ = self->priv->png;
	gtk_file_chooser_add_filter ((GtkFileChooser*) self, _tmp30_);
	_tmp31_ = g_strdup ("*.mm");
	_tmp32_ = g_new0 (gchar*, 1 + 1);
	_tmp32_[0] = _tmp31_;
	_tmp33_ = _tmp32_;
	_tmp33__length1 = 1;
	_tmp34_ = export_dialog_create_filter ("Free Mind", _tmp33_, 1);
	_g_object_unref0 (self->priv->mm);
	self->priv->mm = _tmp34_;
	_tmp33_ = (_vala_array_free (_tmp33_, _tmp33__length1, (GDestroyNotify) g_free), NULL);
	_tmp35_ = self->priv->mm;
	gtk_file_chooser_add_filter ((GtkFileChooser*) self, _tmp35_);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) self, TRUE);
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) _export_dialog_on_response_gtk_dialog_response, self, 0);
	_tmp36_ = filetab;
	_tmp37_ = _tmp36_->filepath;
	export_dialog_set_path (self, _tmp37_);
	return self;
}


ExportDialog* export_dialog_new (FileTab* filetab, const gchar* default_directory, GtkWindow* _parent) {
	return export_dialog_construct (TYPE_EXPORT_DIALOG, filetab, default_directory, _parent);
}


GtkFileFilter* export_dialog_create_filter (const gchar* name, gchar** patterns, int patterns_length1) {
	GtkFileFilter* result = NULL;
	GtkFileFilter* _tmp0_;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* filter;
	GtkFileFilter* _tmp2_;
	const gchar* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = gtk_file_filter_new ();
	_tmp1_ = g_object_ref_sink (_tmp0_);
	filter = _tmp1_;
	_tmp2_ = filter;
	_tmp3_ = name;
	gtk_file_filter_set_name (_tmp2_, _tmp3_);
	_tmp4_ = patterns;
	_tmp4__length1 = patterns_length1;
	{
		gchar** it_collection = NULL;
		gint it_collection_length1 = 0;
		gint _it_collection_size_ = 0;
		gint it_it = 0;
		it_collection = _tmp4_;
		it_collection_length1 = _tmp4__length1;
		for (it_it = 0; it_it < _tmp4__length1; it_it = it_it + 1) {
			gchar* _tmp5_;
			gchar* it = NULL;
			_tmp5_ = g_strdup (it_collection[it_it]);
			it = _tmp5_;
			{
				GtkFileFilter* _tmp6_;
				const gchar* _tmp7_;
				_tmp6_ = filter;
				_tmp7_ = it;
				gtk_file_filter_add_pattern (_tmp6_, _tmp7_);
				_g_free0 (it);
			}
		}
	}
	result = filter;
	return result;
}


guint export_dialog_get_filter_id (ExportDialog* self) {
	guint result = 0U;
	GtkFileFilter* _tmp0_ = NULL;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* filter;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* _tmp3_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = gtk_file_chooser_get_filter ((GtkFileChooser*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	filter = _tmp1_;
	_tmp2_ = filter;
	_tmp3_ = self->priv->txt;
	if (_tmp2_ == _tmp3_) {
		result = (guint) EXPORT_FILTER_ID_TXT;
		_g_object_unref0 (filter);
		return result;
	} else {
		GtkFileFilter* _tmp4_;
		GtkFileFilter* _tmp5_;
		_tmp4_ = filter;
		_tmp5_ = self->priv->html;
		if (_tmp4_ == _tmp5_) {
			result = (guint) EXPORT_FILTER_ID_HTML;
			_g_object_unref0 (filter);
			return result;
		} else {
			GtkFileFilter* _tmp6_;
			GtkFileFilter* _tmp7_;
			_tmp6_ = filter;
			_tmp7_ = self->priv->dhtml;
			if (_tmp6_ == _tmp7_) {
				result = (guint) EXPORT_FILTER_ID_DHTML;
				_g_object_unref0 (filter);
				return result;
			} else {
				GtkFileFilter* _tmp8_;
				GtkFileFilter* _tmp9_;
				_tmp8_ = filter;
				_tmp9_ = self->priv->png;
				if (_tmp8_ == _tmp9_) {
					result = (guint) EXPORT_FILTER_ID_PNG;
					_g_object_unref0 (filter);
					return result;
				} else {
					GtkFileFilter* _tmp10_;
					GtkFileFilter* _tmp11_;
					_tmp10_ = filter;
					_tmp11_ = self->priv->mm;
					if (_tmp10_ == _tmp11_) {
						result = (guint) EXPORT_FILTER_ID_MM;
						_g_object_unref0 (filter);
						return result;
					}
				}
			}
		}
	}
	result = (guint) (-1);
	_g_object_unref0 (filter);
	return result;
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_;
		glong _tmp14_;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_;
		glong _tmp17_;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


void export_dialog_set_path (ExportDialog* self, const gchar* filepath) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filepath != NULL);
	_tmp0_ = filepath;
	if (g_strcmp0 (_tmp0_, "") == 0) {
		const gchar* _tmp1_;
		FileTab* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp1_ = self->default_directory;
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) self, _tmp1_);
		_tmp2_ = self->filetab;
		_tmp3_ = itab_get_title ((ITab*) _tmp2_);
		_tmp4_ = _tmp3_;
		gtk_file_chooser_set_current_name ((GtkFileChooser*) self, _tmp4_);
	} else {
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_ = NULL;
		gchar* fname;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
		_tmp5_ = filepath;
		_tmp6_ = g_path_get_dirname (_tmp5_);
		_tmp7_ = _tmp6_;
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) self, _tmp7_);
		_g_free0 (_tmp7_);
		_tmp8_ = filepath;
		_tmp9_ = g_path_get_basename (_tmp8_);
		fname = _tmp9_;
		_tmp10_ = fname;
		_tmp11_ = fname;
		_tmp12_ = strlen (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = string_substring (_tmp10_, (glong) 0, (glong) (_tmp13_ - 4));
		_tmp15_ = _tmp14_;
		gtk_file_chooser_set_current_name ((GtkFileChooser*) self, _tmp15_);
		_g_free0 (_tmp15_);
		_g_free0 (fname);
	}
}


void export_dialog_restart_response (ExportDialog* self, gint response_id) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	g_signal_stop_emission_by_name (self, "response");
	_tmp0_ = response_id;
	gtk_dialog_response ((GtkDialog*) self, _tmp0_);
}


void export_dialog_on_response (ExportDialog* self, gint response_id) {
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* fname;
	GtkFileFilter* _tmp2_ = NULL;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* filter;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = response_id;
	if (_tmp0_ != ((gint) GTK_RESPONSE_ACCEPT)) {
		return;
	}
	_tmp1_ = gtk_file_chooser_get_filename ((GtkFileChooser*) self);
	fname = _tmp1_;
	_tmp2_ = gtk_file_chooser_get_filter ((GtkFileChooser*) self);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	filter = _tmp3_;
	_tmp4_ = filter;
	_tmp5_ = self->priv->txt;
	if (_tmp4_ == _tmp5_) {
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_;
		_tmp6_ = fname;
		_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) (-1));
		_tmp8_ = _tmp7_;
		_tmp9_ = g_str_has_suffix (_tmp8_, ".txt");
		_tmp10_ = !_tmp9_;
		_g_free0 (_tmp8_);
		if (_tmp10_) {
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_;
			_tmp11_ = fname;
			_tmp12_ = g_strconcat (_tmp11_, ".txt", NULL);
			_tmp13_ = _tmp12_;
			_tmp14_ = gtk_file_chooser_set_filename ((GtkFileChooser*) self, _tmp13_);
			_tmp15_ = _tmp14_;
			_g_free0 (_tmp13_);
			if (_tmp15_) {
				gint _tmp16_;
				_tmp16_ = response_id;
				export_dialog_restart_response (self, _tmp16_);
			}
		}
	} else {
		GtkFileFilter* _tmp17_;
		GtkFileFilter* _tmp18_;
		_tmp17_ = filter;
		_tmp18_ = self->priv->html;
		if (_tmp17_ == _tmp18_) {
			gboolean _tmp19_ = FALSE;
			const gchar* _tmp20_;
			gchar* _tmp21_ = NULL;
			gchar* _tmp22_;
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_;
			gboolean _tmp29_;
			_tmp20_ = fname;
			_tmp21_ = g_utf8_strdown (_tmp20_, (gssize) (-1));
			_tmp22_ = _tmp21_;
			_tmp23_ = g_str_has_suffix (_tmp22_, ".htm");
			_tmp24_ = !_tmp23_;
			_g_free0 (_tmp22_);
			if (_tmp24_) {
				const gchar* _tmp25_;
				gchar* _tmp26_ = NULL;
				gchar* _tmp27_;
				gboolean _tmp28_ = FALSE;
				_tmp25_ = fname;
				_tmp26_ = g_utf8_strdown (_tmp25_, (gssize) (-1));
				_tmp27_ = _tmp26_;
				_tmp28_ = g_str_has_suffix (_tmp27_, ".html");
				_tmp19_ = !_tmp28_;
				_g_free0 (_tmp27_);
			} else {
				_tmp19_ = FALSE;
			}
			_tmp29_ = _tmp19_;
			if (_tmp29_) {
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_;
				_tmp30_ = fname;
				_tmp31_ = g_strconcat (_tmp30_, ".html", NULL);
				_tmp32_ = _tmp31_;
				_tmp33_ = gtk_file_chooser_set_filename ((GtkFileChooser*) self, _tmp32_);
				_tmp34_ = _tmp33_;
				_g_free0 (_tmp32_);
				if (_tmp34_) {
					gint _tmp35_;
					_tmp35_ = response_id;
					export_dialog_restart_response (self, _tmp35_);
				}
			}
		} else {
			GtkFileFilter* _tmp36_;
			GtkFileFilter* _tmp37_;
			_tmp36_ = filter;
			_tmp37_ = self->priv->dhtml;
			if (_tmp36_ == _tmp37_) {
				gboolean _tmp38_ = FALSE;
				const gchar* _tmp39_;
				gchar* _tmp40_ = NULL;
				gchar* _tmp41_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_;
				gboolean _tmp48_;
				_tmp39_ = fname;
				_tmp40_ = g_utf8_strdown (_tmp39_, (gssize) (-1));
				_tmp41_ = _tmp40_;
				_tmp42_ = g_str_has_suffix (_tmp41_, ".dhtm");
				_tmp43_ = !_tmp42_;
				_g_free0 (_tmp41_);
				if (_tmp43_) {
					const gchar* _tmp44_;
					gchar* _tmp45_ = NULL;
					gchar* _tmp46_;
					gboolean _tmp47_ = FALSE;
					_tmp44_ = fname;
					_tmp45_ = g_utf8_strdown (_tmp44_, (gssize) (-1));
					_tmp46_ = _tmp45_;
					_tmp47_ = g_str_has_suffix (_tmp46_, ".dhtml");
					_tmp38_ = !_tmp47_;
					_g_free0 (_tmp46_);
				} else {
					_tmp38_ = FALSE;
				}
				_tmp48_ = _tmp38_;
				if (_tmp48_) {
					const gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
					gboolean _tmp52_ = FALSE;
					gboolean _tmp53_;
					_tmp49_ = fname;
					_tmp50_ = g_strconcat (_tmp49_, ".dhtml", NULL);
					_tmp51_ = _tmp50_;
					_tmp52_ = gtk_file_chooser_set_filename ((GtkFileChooser*) self, _tmp51_);
					_tmp53_ = _tmp52_;
					_g_free0 (_tmp51_);
					if (_tmp53_) {
						gint _tmp54_;
						_tmp54_ = response_id;
						export_dialog_restart_response (self, _tmp54_);
					}
				}
			} else {
				GtkFileFilter* _tmp55_;
				GtkFileFilter* _tmp56_;
				_tmp55_ = filter;
				_tmp56_ = self->priv->png;
				if (_tmp55_ == _tmp56_) {
					const gchar* _tmp57_;
					gchar* _tmp58_ = NULL;
					gchar* _tmp59_;
					gboolean _tmp60_ = FALSE;
					gboolean _tmp61_;
					_tmp57_ = fname;
					_tmp58_ = g_utf8_strdown (_tmp57_, (gssize) (-1));
					_tmp59_ = _tmp58_;
					_tmp60_ = g_str_has_suffix (_tmp59_, ".png");
					_tmp61_ = !_tmp60_;
					_g_free0 (_tmp59_);
					if (_tmp61_) {
						const gchar* _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
						gboolean _tmp65_ = FALSE;
						gboolean _tmp66_;
						_tmp62_ = fname;
						_tmp63_ = g_strconcat (_tmp62_, ".png", NULL);
						_tmp64_ = _tmp63_;
						_tmp65_ = gtk_file_chooser_set_filename ((GtkFileChooser*) self, _tmp64_);
						_tmp66_ = _tmp65_;
						_g_free0 (_tmp64_);
						if (_tmp66_) {
							gint _tmp67_;
							_tmp67_ = response_id;
							export_dialog_restart_response (self, _tmp67_);
						}
					}
				} else {
					GtkFileFilter* _tmp68_;
					GtkFileFilter* _tmp69_;
					_tmp68_ = filter;
					_tmp69_ = self->priv->mm;
					if (_tmp68_ == _tmp69_) {
						const gchar* _tmp70_;
						gchar* _tmp71_ = NULL;
						gchar* _tmp72_;
						gboolean _tmp73_ = FALSE;
						gboolean _tmp74_;
						_tmp70_ = fname;
						_tmp71_ = g_utf8_strdown (_tmp70_, (gssize) (-1));
						_tmp72_ = _tmp71_;
						_tmp73_ = g_str_has_suffix (_tmp72_, ".mm");
						_tmp74_ = !_tmp73_;
						_g_free0 (_tmp72_);
						if (_tmp74_) {
							const gchar* _tmp75_;
							gchar* _tmp76_;
							gchar* _tmp77_;
							gboolean _tmp78_ = FALSE;
							gboolean _tmp79_;
							_tmp75_ = fname;
							_tmp76_ = g_strconcat (_tmp75_, ".mm", NULL);
							_tmp77_ = _tmp76_;
							_tmp78_ = gtk_file_chooser_set_filename ((GtkFileChooser*) self, _tmp77_);
							_tmp79_ = _tmp78_;
							_g_free0 (_tmp77_);
							if (_tmp79_) {
								gint _tmp80_;
								_tmp80_ = response_id;
								export_dialog_restart_response (self, _tmp80_);
							}
						}
					}
				}
			}
		}
	}
	_g_object_unref0 (filter);
	_g_free0 (fname);
}


gchar* export_dialog_get_suffixed_filename (ExportDialog* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* fname;
	GtkFileFilter* _tmp1_ = NULL;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* filter;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_file_chooser_get_filename ((GtkFileChooser*) self);
	fname = _tmp0_;
	_tmp1_ = gtk_file_chooser_get_filter ((GtkFileChooser*) self);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	filter = _tmp2_;
	_tmp3_ = filter;
	_tmp4_ = self->priv->txt;
	if (_tmp3_ == _tmp4_) {
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
		_tmp5_ = fname;
		_tmp6_ = g_utf8_strdown (_tmp5_, (gssize) (-1));
		_tmp7_ = _tmp6_;
		_tmp8_ = g_str_has_suffix (_tmp7_, ".txt");
		_tmp9_ = !_tmp8_;
		_g_free0 (_tmp7_);
		if (_tmp9_) {
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp10_ = fname;
			_tmp11_ = g_strconcat (_tmp10_, ".txt", NULL);
			result = _tmp11_;
			_g_object_unref0 (filter);
			_g_free0 (fname);
			return result;
		}
	} else {
		GtkFileFilter* _tmp12_;
		GtkFileFilter* _tmp13_;
		_tmp12_ = filter;
		_tmp13_ = self->priv->html;
		if (_tmp12_ == _tmp13_) {
			gboolean _tmp14_ = FALSE;
			const gchar* _tmp15_;
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_;
			gboolean _tmp24_;
			_tmp15_ = fname;
			_tmp16_ = g_utf8_strdown (_tmp15_, (gssize) (-1));
			_tmp17_ = _tmp16_;
			_tmp18_ = g_str_has_suffix (_tmp17_, ".htm");
			_tmp19_ = !_tmp18_;
			_g_free0 (_tmp17_);
			if (_tmp19_) {
				const gchar* _tmp20_;
				gchar* _tmp21_ = NULL;
				gchar* _tmp22_;
				gboolean _tmp23_ = FALSE;
				_tmp20_ = fname;
				_tmp21_ = g_utf8_strdown (_tmp20_, (gssize) (-1));
				_tmp22_ = _tmp21_;
				_tmp23_ = g_str_has_suffix (_tmp22_, ".html");
				_tmp14_ = !_tmp23_;
				_g_free0 (_tmp22_);
			} else {
				_tmp14_ = FALSE;
			}
			_tmp24_ = _tmp14_;
			if (_tmp24_) {
				const gchar* _tmp25_;
				gchar* _tmp26_;
				_tmp25_ = fname;
				_tmp26_ = g_strconcat (_tmp25_, ".html", NULL);
				result = _tmp26_;
				_g_object_unref0 (filter);
				_g_free0 (fname);
				return result;
			}
		} else {
			GtkFileFilter* _tmp27_;
			GtkFileFilter* _tmp28_;
			_tmp27_ = filter;
			_tmp28_ = self->priv->dhtml;
			if (_tmp27_ == _tmp28_) {
				gboolean _tmp29_ = FALSE;
				const gchar* _tmp30_;
				gchar* _tmp31_ = NULL;
				gchar* _tmp32_;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_;
				gboolean _tmp39_;
				_tmp30_ = fname;
				_tmp31_ = g_utf8_strdown (_tmp30_, (gssize) (-1));
				_tmp32_ = _tmp31_;
				_tmp33_ = g_str_has_suffix (_tmp32_, ".dhtm");
				_tmp34_ = !_tmp33_;
				_g_free0 (_tmp32_);
				if (_tmp34_) {
					const gchar* _tmp35_;
					gchar* _tmp36_ = NULL;
					gchar* _tmp37_;
					gboolean _tmp38_ = FALSE;
					_tmp35_ = fname;
					_tmp36_ = g_utf8_strdown (_tmp35_, (gssize) (-1));
					_tmp37_ = _tmp36_;
					_tmp38_ = g_str_has_suffix (_tmp37_, ".dhtml");
					_tmp29_ = !_tmp38_;
					_g_free0 (_tmp37_);
				} else {
					_tmp29_ = FALSE;
				}
				_tmp39_ = _tmp29_;
				if (_tmp39_) {
					const gchar* _tmp40_;
					gchar* _tmp41_;
					_tmp40_ = fname;
					_tmp41_ = g_strconcat (_tmp40_, ".dhtml", NULL);
					result = _tmp41_;
					_g_object_unref0 (filter);
					_g_free0 (fname);
					return result;
				}
			} else {
				GtkFileFilter* _tmp42_;
				GtkFileFilter* _tmp43_;
				_tmp42_ = filter;
				_tmp43_ = self->priv->png;
				if (_tmp42_ == _tmp43_) {
					const gchar* _tmp44_;
					gchar* _tmp45_ = NULL;
					gchar* _tmp46_;
					gboolean _tmp47_ = FALSE;
					gboolean _tmp48_;
					_tmp44_ = fname;
					_tmp45_ = g_utf8_strdown (_tmp44_, (gssize) (-1));
					_tmp46_ = _tmp45_;
					_tmp47_ = g_str_has_suffix (_tmp46_, ".png");
					_tmp48_ = !_tmp47_;
					_g_free0 (_tmp46_);
					if (_tmp48_) {
						const gchar* _tmp49_;
						gchar* _tmp50_;
						_tmp49_ = fname;
						_tmp50_ = g_strconcat (_tmp49_, ".png", NULL);
						result = _tmp50_;
						_g_object_unref0 (filter);
						_g_free0 (fname);
						return result;
					}
				} else {
					GtkFileFilter* _tmp51_;
					GtkFileFilter* _tmp52_;
					_tmp51_ = filter;
					_tmp52_ = self->priv->mm;
					if (_tmp51_ == _tmp52_) {
						const gchar* _tmp53_;
						gchar* _tmp54_ = NULL;
						gchar* _tmp55_;
						gboolean _tmp56_ = FALSE;
						gboolean _tmp57_;
						_tmp53_ = fname;
						_tmp54_ = g_utf8_strdown (_tmp53_, (gssize) (-1));
						_tmp55_ = _tmp54_;
						_tmp56_ = g_str_has_suffix (_tmp55_, ".mm");
						_tmp57_ = !_tmp56_;
						_g_free0 (_tmp55_);
						if (_tmp57_) {
							const gchar* _tmp58_;
							gchar* _tmp59_;
							_tmp58_ = fname;
							_tmp59_ = g_strconcat (_tmp58_, ".mm", NULL);
							result = _tmp59_;
							_g_object_unref0 (filter);
							_g_free0 (fname);
							return result;
						}
					}
				}
			}
		}
	}
	result = fname;
	_g_object_unref0 (filter);
	return result;
}


static void export_dialog_class_init (ExportDialogClass * klass) {
	export_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ExportDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = export_dialog_finalize;
}


static void export_dialog_instance_init (ExportDialog * self) {
	self->priv = EXPORT_DIALOG_GET_PRIVATE (self);
}


static void export_dialog_finalize (GObject* obj) {
	ExportDialog * self;
	self = EXPORT_DIALOG (obj);
	_g_object_unref0 (self->filetab);
	_g_free0 (self->default_directory);
	_g_object_unref0 (self->priv->txt);
	_g_object_unref0 (self->priv->html);
	_g_object_unref0 (self->priv->dhtml);
	_g_object_unref0 (self->priv->png);
	_g_object_unref0 (self->priv->mm);
	G_OBJECT_CLASS (export_dialog_parent_class)->finalize (obj);
}


GType export_dialog_get_type (void) {
	static volatile gsize export_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&export_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ExportDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) export_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExportDialog), 0, (GInstanceInitFunc) export_dialog_instance_init, NULL };
		GType export_dialog_type_id;
		export_dialog_type_id = g_type_register_static (GTK_TYPE_FILE_CHOOSER_DIALOG, "ExportDialog", &g_define_type_info, 0);
		g_once_init_leave (&export_dialog_type_id__volatile, export_dialog_type_id);
	}
	return export_dialog_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



