/* print.c generated by valac 0.16.1, the Vala compiler
 * generated from print.vala, do not modify */

/*
 * DESCRIPTION      Printing support of mind map.
 * PROJECT          Mind Map Architect
 * AUTHOR           Ondrej Tuma <mcbig@zeropage.cz>
 *
 * Copyright (C) Ondrej Tuma 2011
 * Code is present with BSD licence.
 */
/* XXX: could be singleton*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gee.h>


#define TYPE_PRINT (print_get_type ())
#define PRINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PRINT, Print))
#define PRINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PRINT, PrintClass))
#define IS_PRINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PRINT))
#define IS_PRINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PRINT))
#define PRINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PRINT, PrintClass))

typedef struct _Print Print;
typedef struct _PrintClass PrintClass;
typedef struct _PrintPrivate PrintPrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NodePrivate NodePrivate;

#define TYPE_MIND_MAP (mind_map_get_type ())
#define MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIND_MAP, MindMap))
#define MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIND_MAP, MindMapClass))
#define IS_MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIND_MAP))
#define IS_MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIND_MAP))
#define MIND_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIND_MAP, MindMapClass))

typedef struct _MindMap MindMap;
typedef struct _MindMapClass MindMapClass;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _Print {
	GObject parent_instance;
	PrintPrivate * priv;
	GtkPrintOperation* po;
	Node* node;
	Preferences* pref;
};

struct _PrintClass {
	GObjectClass parent_class;
};

struct _Node {
	GObject parent_instance;
	NodePrivate * priv;
	GdkDrawable* window;
	Node* parent;
	MindMap* map;
	GList* children;
	gchar* text;
	guint direction;
	gdouble weight;
	gdouble points;
	gint function;
	GdkColor color;
	GdkRectangle area;
	GdkRectangle full_left;
	GdkRectangle full_right;
	PangoFontDescription* font_desc;
	gboolean is_expand;
	gboolean visible;
	gboolean default_color;
	GeeHashSet* flags;
};

struct _NodeClass {
	GObjectClass parent_class;
};


static gpointer print_parent_class = NULL;

GType print_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
GType preferences_get_type (void) G_GNUC_CONST;
enum  {
	PRINT_DUMMY_PROPERTY
};
Print* print_new (Preferences* pref, Node* node);
Print* print_construct (GType object_type, Preferences* pref, Node* node);
void preferences_load_print_settings (Preferences* self, GtkPrintSettings* settings);
void print_begin_print (Print* self, GtkPrintContext* context);
static void _print_begin_print_gtk_print_operation_begin_print (GtkPrintOperation* _sender, GtkPrintContext* context, gpointer self);
void print_draw_page (Print* self, GtkPrintContext* context, gint page_nr);
static void _print_draw_page_gtk_print_operation_draw_page (GtkPrintOperation* _sender, GtkPrintContext* context, gint page_nr, gpointer self);
void print_run (Print* self, GtkWindow* parent);
void preferences_save_print_settings (Preferences* self, GtkPrintSettings* settings, GError** error);
GType mind_map_get_type (void) G_GNUC_CONST;
void exporter_cairo_get_translation (gint width, gint height, Node* node, gdouble* x, gdouble* y);
void node_draw_tree (Node* self, cairo_t* cr);
static void print_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _print_begin_print_gtk_print_operation_begin_print (GtkPrintOperation* _sender, GtkPrintContext* context, gpointer self) {
	print_begin_print (self, context);
}


static void _print_draw_page_gtk_print_operation_draw_page (GtkPrintOperation* _sender, GtkPrintContext* context, gint page_nr, gpointer self) {
	print_draw_page (self, context, page_nr);
}


Print* print_construct (GType object_type, Preferences* pref, Node* node) {
	Print * self = NULL;
	Preferences* _tmp0_;
	Preferences* _tmp1_;
	Node* _tmp2_;
	Node* _tmp3_;
	GtkPrintOperation* _tmp4_;
	GtkPrintOperation* _tmp5_;
	GtkPageSetup* _tmp6_;
	GtkPageSetup* page_setup;
	GtkPrintOperation* _tmp7_;
	GtkPrintSettings* _tmp8_;
	GtkPrintSettings* print_settings;
	Preferences* _tmp9_;
	GtkPrintOperation* _tmp10_;
	GtkPrintOperation* _tmp11_;
	GtkPrintOperation* _tmp12_;
	g_return_val_if_fail (pref != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	self = (Print*) g_object_new (object_type, NULL);
	_tmp0_ = pref;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->pref);
	self->pref = _tmp1_;
	_tmp2_ = node;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->node);
	self->node = _tmp3_;
	_tmp4_ = gtk_print_operation_new ();
	_g_object_unref0 (self->po);
	self->po = _tmp4_;
	_tmp5_ = self->po;
	gtk_print_operation_set_embed_page_setup (_tmp5_, TRUE);
	_tmp6_ = gtk_page_setup_new ();
	page_setup = _tmp6_;
	gtk_page_setup_set_orientation (page_setup, GTK_PAGE_ORIENTATION_LANDSCAPE);
	_tmp7_ = self->po;
	gtk_print_operation_set_default_page_setup (_tmp7_, page_setup);
	_tmp8_ = gtk_print_settings_new ();
	print_settings = _tmp8_;
	_tmp9_ = pref;
	preferences_load_print_settings (_tmp9_, print_settings);
	_tmp10_ = self->po;
	gtk_print_operation_set_print_settings (_tmp10_, print_settings);
	_tmp11_ = self->po;
	g_signal_connect_object (_tmp11_, "begin-print", (GCallback) _print_begin_print_gtk_print_operation_begin_print, self, 0);
	_tmp12_ = self->po;
	g_signal_connect_object (_tmp12_, "draw-page", (GCallback) _print_draw_page_gtk_print_operation_draw_page, self, 0);
	_g_object_unref0 (print_settings);
	_g_object_unref0 (page_setup);
	return self;
}


Print* print_new (Preferences* pref, Node* node) {
	return print_construct (TYPE_PRINT, pref, node);
}


void print_run (Print* self, GtkWindow* parent) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	{
		GtkPrintOperation* _tmp0_;
		GtkWindow* _tmp1_;
		GtkPrintOperationResult _tmp2_ = 0;
		GtkPrintOperationResult res;
		GtkPrintOperationResult _tmp3_;
		GtkPrintOperationResult _tmp5_;
		_tmp0_ = self->po;
		_tmp1_ = parent;
		_tmp2_ = gtk_print_operation_run (_tmp0_, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG, _tmp1_, &_inner_error_);
		res = _tmp2_;
		if (_inner_error_ != NULL) {
			goto __catch18_g_error;
		}
		_tmp3_ = res;
		if (_tmp3_ == GTK_PRINT_OPERATION_RESULT_ERROR) {
			GtkPrintOperation* _tmp4_;
			_tmp4_ = self->po;
			gtk_print_operation_get_error (_tmp4_, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch18_g_error;
			}
		}
		_tmp5_ = res;
		if (_tmp5_ != GTK_PRINT_OPERATION_RESULT_CANCEL) {
			Preferences* _tmp6_;
			GtkPrintOperation* _tmp7_;
			GtkPrintSettings* _tmp8_ = NULL;
			_tmp6_ = self->pref;
			_tmp7_ = self->po;
			_tmp8_ = gtk_print_operation_get_print_settings (_tmp7_);
			preferences_save_print_settings (_tmp6_, _tmp8_, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch18_g_error;
			}
		}
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* e = NULL;
		GtkWindow* _tmp9_;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GtkMessageDialog* _tmp15_;
		GtkMessageDialog* _tmp16_;
		GtkMessageDialog* _tmp17_;
		GtkMessageDialog* dialog;
		FILE* _tmp18_;
		GError* _tmp19_;
		const gchar* _tmp20_;
		GtkMessageDialog* _tmp21_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = parent;
		_tmp10_ = _ ("Printing error:");
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		_tmp13_ = g_strconcat (_tmp10_, _tmp12_, NULL);
		_tmp14_ = _tmp13_;
		_tmp15_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp9_, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, _tmp14_);
		_tmp16_ = g_object_ref_sink (_tmp15_);
		_tmp17_ = _tmp16_;
		_g_free0 (_tmp14_);
		dialog = _tmp17_;
		_tmp18_ = stderr;
		_tmp19_ = e;
		_tmp20_ = _tmp19_->message;
		fprintf (_tmp18_, "%s\n", _tmp20_);
		_tmp21_ = dialog;
		gtk_dialog_run ((GtkDialog*) _tmp21_);
		_g_object_unref0 (dialog);
		_g_error_free0 (e);
	}
	__finally18:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void print_begin_print (Print* self, GtkPrintContext* context) {
	GtkPrintOperation* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = self->po;
	gtk_print_operation_set_n_pages (_tmp0_, 1);
}


static gpointer _cairo_reference0 (gpointer self) {
	return self ? cairo_reference (self) : NULL;
}


void print_draw_page (Print* self, GtkPrintContext* context, gint page_nr) {
	gint width = 0;
	gint height = 0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble page_height = 0.0;
	gdouble page_width = 0.0;
	gdouble scale_width = 0.0;
	gdouble scale_height = 0.0;
	GtkPrintContext* _tmp0_;
	cairo_t* _tmp1_ = NULL;
	cairo_t* _tmp2_;
	cairo_t* cr;
	Node* _tmp3_;
	GdkDrawable* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GtkPrintContext* _tmp7_;
	gdouble _tmp8_ = 0.0;
	GtkPrintContext* _tmp9_;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_;
	gint _tmp12_;
	gdouble _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	Node* _tmp17_;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gboolean _tmp20_ = FALSE;
	gdouble _tmp21_;
	gboolean _tmp24_;
	cairo_t* _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	Node* _tmp39_;
	cairo_t* _tmp40_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = context;
	_tmp1_ = gtk_print_context_get_cairo_context (_tmp0_);
	_tmp2_ = _cairo_reference0 (_tmp1_);
	cr = _tmp2_;
	_tmp3_ = self->node;
	_tmp4_ = _tmp3_->window;
	gdk_drawable_get_size (_tmp4_, &_tmp5_, &_tmp6_);
	width = _tmp5_;
	height = _tmp6_;
	_tmp7_ = context;
	_tmp8_ = gtk_print_context_get_width (_tmp7_);
	page_width = _tmp8_;
	_tmp9_ = context;
	_tmp10_ = gtk_print_context_get_height (_tmp9_);
	page_height = _tmp10_;
	_tmp11_ = page_width;
	_tmp12_ = width;
	scale_width = _tmp11_ / _tmp12_;
	_tmp13_ = page_height;
	_tmp14_ = height;
	scale_height = _tmp13_ / _tmp14_;
	_tmp15_ = width;
	_tmp16_ = height;
	_tmp17_ = self->node;
	exporter_cairo_get_translation (_tmp15_, _tmp16_, _tmp17_, &_tmp18_, &_tmp19_);
	x = _tmp18_;
	y = _tmp19_;
	_tmp21_ = scale_width;
	if (_tmp21_ < ((gdouble) 1)) {
		gdouble _tmp22_;
		gdouble _tmp23_;
		_tmp22_ = scale_width;
		_tmp23_ = scale_height;
		_tmp20_ = _tmp22_ < _tmp23_;
	} else {
		_tmp20_ = FALSE;
	}
	_tmp24_ = _tmp20_;
	if (_tmp24_) {
		cairo_t* _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
		_tmp25_ = cr;
		_tmp26_ = scale_width;
		_tmp27_ = scale_width;
		cairo_scale (_tmp25_, _tmp26_, _tmp27_);
	} else {
		gboolean _tmp28_ = FALSE;
		gdouble _tmp29_;
		gboolean _tmp32_;
		_tmp29_ = scale_height;
		if (_tmp29_ < ((gdouble) 1)) {
			gdouble _tmp30_;
			gdouble _tmp31_;
			_tmp30_ = scale_height;
			_tmp31_ = scale_width;
			_tmp28_ = _tmp30_ < _tmp31_;
		} else {
			_tmp28_ = FALSE;
		}
		_tmp32_ = _tmp28_;
		if (_tmp32_) {
			cairo_t* _tmp33_;
			gdouble _tmp34_;
			gdouble _tmp35_;
			_tmp33_ = cr;
			_tmp34_ = scale_height;
			_tmp35_ = scale_height;
			cairo_scale (_tmp33_, _tmp34_, _tmp35_);
		}
	}
	_tmp36_ = cr;
	_tmp37_ = x;
	_tmp38_ = y;
	cairo_translate (_tmp36_, _tmp37_, _tmp38_);
	_tmp39_ = self->node;
	_tmp40_ = cr;
	node_draw_tree (_tmp39_, _tmp40_);
	_cairo_destroy0 (cr);
}


static void print_class_init (PrintClass * klass) {
	print_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = print_finalize;
}


static void print_instance_init (Print * self) {
}


static void print_finalize (GObject* obj) {
	Print * self;
	self = PRINT (obj);
	_g_object_unref0 (self->po);
	_g_object_unref0 (self->node);
	_g_object_unref0 (self->pref);
	G_OBJECT_CLASS (print_parent_class)->finalize (obj);
}


GType print_get_type (void) {
	static volatile gsize print_type_id__volatile = 0;
	if (g_once_init_enter (&print_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrintClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) print_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Print), 0, (GInstanceInitFunc) print_instance_init, NULL };
		GType print_type_id;
		print_type_id = g_type_register_static (G_TYPE_OBJECT, "Print", &g_define_type_info, 0);
		g_once_init_leave (&print_type_id__volatile, print_type_id);
	}
	return print_type_id__volatile;
}



